# Measures.jl

[![Build
Status](https://travis-ci.org/JuliaGraphics/Measures.jl.svg?branch=master)](https://travis-ci.org/JuliaGraphics/Measures.jl)

This library generalizes and unifies the notion of measures used in
[Compose](https://github.com/GiovineItalia/Compose.jl),
[Compose3D](https://github.com/rohitvarkey/Compose3D.jl),
and [Escher](https://github.com/shashi/Escher.jl).

It allows building up and representing expressions involving differing types of
units that are then evaluated, resolving them into absolute units.

# Length
# ------

resolve(box::AbsoluteBox, x::Length{:mm}) = x
resolve(box::AbsoluteBox, x::Length{:w})  = width(box).value * x.value * mm
resolve(box::AbsoluteBox, x::Length{:h})  = height(box).value * x.value * mm
resolve(box::AbsoluteBox, x::Length{:d})  = depth(box).value * x.value * mm


# Operations
# ----------

resolve(box::AbsoluteBox, x::Neg) = -resolve(box, x.a)
resolve(box::AbsoluteBox, x::Add) = resolve(box, x.a) + resolve(box, x.b)
resolve(box::AbsoluteBox, x::Mul) = resolve(box, x.a) * x.b
resolve(box::AbsoluteBox, x::Div) = resolve(box, x.a) / x.b
resolve(box::AbsoluteBox, x::Min) = min(resolve(box, x.a), resolve(box, x.b))
resolve(box::AbsoluteBox, x::Max) = max(resolve(box, x.a), resolve(box, x.b))
resolve(box::AbsoluteBox, p::Vec) = map(x -> resolve(box, x), p) + box.x0
resolve(outer::AbsoluteBox, box::BoundingBox) =
    BoundingBox(resolve(outer, box.x0), map(x -> resolve(outer, x), box.a))

import Base.==

struct Length{U, T} <: Measure
    value::T
end
Length(unit::Symbol, x::T) where T = Length{unit, T}(x)

const AbsoluteLength = Length{:mm, Float64}

Base.zero(x::AbsoluteLength) = AbsoluteLength(0.0)
Base.convert(::Type{Float64}, x::AbsoluteLength) = x.value

Base.convert(::Type{Length{U, T1}}, x::Length{U, T2}) where {U, T1 <: Number, T2 <: Number} =
    Length{U, T1}(x.value)

==(x::Length{U}, y::Length{U}) where U = x.value == y.value
Base.isequal(x::Length{U}, y::Length{U}) where U = isequal(x.value, y.value)
Base.hash(x::Length{U}) where U = hash(x.value, hash(U))

# Operations
# ----------

Neg(x::T) where T <: Length = T(-x.value)
Div(a::Length{U}, b::Number) where U = Length(U, a.value / b)
Div(a::Length{U}, b::Length{U}) where U = a.value / b.value
Mul(a::Length{U}, b::Number) where U = Length(U, a.value * b)
Max(a::Length{U}, b::Length{U}) where U = Length(U, max(a.value, b.value))
Min(a::Length{U}, b::Length{U}) where U = Length(U, min(a.value, b.value))

Base.:+(a::Length{U}, b::Length{U}) where U = Length(U, a.value + b.value)
Base.:-(a::Length{U}, b::Length{U}) where U = Length(U, a.value - b.value)

iszero(x::Length) = x.value == 0.0

Base.abs(a::T) where {T <: Length} = T(abs(a.value))
Base.isless(a::Length{U}, b::Length{U}) where U = a.value < b.value
Base.oneunit(a::Type{Length{U,T}}) where {U,T} = Length(U, one(T))

isabsolute(::Type{Length{U,T}}) where {U,T} = !in(U, [:w,:h])


# Constants
# ---------

const mm   = AbsoluteLength(1.0)
const cm   = AbsoluteLength(10.0)
const inch = AbsoluteLength(25.4)
const pt   = inch/72.0

const w    = Length{:w, Float64}(1.0)
const h    = Length{:h, Float64}(1.0)
const d    = Length{:d, Float64}(1.0)

# Higher-order measures

const Vec{N} = NTuple{N, Measure}
const Vec2 = Vec{2}
const Vec3 = Vec{3}

isabsolute(p::Vec) = false
isabsolute(p::NTuple{N, AbsoluteLength}) where N = true

const AbsoluteVec{N} = NTuple{N, Length{:mm, Float64}}
const AbsoluteVec2 = AbsoluteVec{2}
const AbsoluteVec3 = AbsoluteVec{3}

Base.:+(a::Vec, b::Vec)  = map(+, a, b)
Base.:-(a::Vec, b::Vec)  = map(-, a, b)
Base.:/(a::Vec, b::Number) = map(x -> x/b, a)
Base.:*(a::Vec, b::Number) = map(x -> x*b, a)
Base.:*(a::Number, b::Vec) = b*a

@generated function Base.:+(a::Vec{N}, b::Vec{N}) where N
    Expr(:tuple, [:(a[$i] + b[$i]) for i=1:N]...)
end

abstract type MeasureOp{n} <: Measure end
abstract type UnaryOp{A} <: MeasureOp{1} end
abstract type ScalarOp{A} <: MeasureOp{2} end
abstract type BinaryOp{A, B} <: MeasureOp{2} end

struct Neg{A <: Measure} <: UnaryOp{A}
    a::A
end

struct Add{A <: Measure, B <: Measure} <: BinaryOp{A, B}
    a::A
    b::B
end

struct Min{A <: Measure, B <: Measure} <: BinaryOp{A, B}
    a::A
    b::B
end

struct Max{A <: Measure, B <: Measure} <: BinaryOp{A, B}
    a::A
    b::B
end

struct Div{A <: Measure} <: ScalarOp{A}
    a::A
    b::Number
end

struct Mul{A <: Measure} <: ScalarOp{A}
    a::A
    b::Number
end

# Easy simplifications
# TODO: Add more simplifications
Neg(x::Neg) = x.a
iszero(x::Measure) = false

Base.:+(a::Measure, b::Measure) = Add(a, b)
Base.:-(a::Measure) = Neg(a)
Base.:-(a::Neg) = a.value
Base.:-(a::Measure, b::Measure) = Add(a, -b)
Base.:/(a::Measure, b::Number) = Div(a, b)
Base.:/(a::T, b::T) where T <: Measure = Div(a, b)
Base.:*(a::Measure, b::Number) = Mul(a, b)
Base.:*(a::Number, b::Measure) = Mul(b, a)
Base.min(a::Measure, b::Measure) = Min(a, b)
Base.max(a::Measure, b::Measure) = Max(a, b)

module Measures

export Measure, Length, AbsoluteLength, BoundingBox, AbsoluteBox, Absolute2DBox,
       Absolute3DBox, Vec, Vec2, Vec3, AbsoluteVec, AbsoluteVec2, AbsoluteVec3,
       isabsolute, resolve,
        mm, cm, inch, pt, width, height

abstract type Measure end

include("operations.jl")
include("length.jl")
include("point.jl")
include("boundingbox.jl")
include("resolution.jl")


Base.show(out::IO, x::Length{U}) where U = print(out, x.value, U)
Base.show(out::IO, x::Neg) = print(out, "-", x.a)
Base.show(out::IO, x::Add) = print(out, x.a, " + ", x.b)
Base.show(out::IO, x::Min) = print(out, "min(", x.a, ", ", x.b, ")")
Base.show(out::IO, x::Max) = print(out, "max(", x.a, ", ", x.b, ")")
Base.show(out::IO, x::Div) = print(out,  x.a, " / ", x.b)
Base.show(out::IO, x::Mul) = print(out,  x.a, " * ", x.b)

Broadcast.broadcastable(x::T) where T<:Measure = Ref(x)

end # module Measures

using Test
using Measures

const imm = Length(:mm, 1)
const rmm = Length(:mm, 1//1)

const xx = Length(:xx, 1.0)

@testset "Bounding boxes" begin
    @testset "Valid bounding box constructors" begin
        @test BoundingBox((0mm, 1mm), 1mm, 2mm) ===
            BoundingBox((0mm, 1mm), 1mm, 2mm)
        @test BoundingBox((2mm, 1mm, 3mm), 1mm, 2mm, 4mm) ===
            BoundingBox((2mm, 1mm, 3mm), 1mm, 2mm, 4mm)
    end

    @testset "Invalid bounding box constructors" begin
        @test_throws MethodError BoundingBox((0mm,), 1mm, 2mm)
        @test_throws MethodError BoundingBox((0mm, 3mm, 8mm), 1mm, 4mm)
        @test_throws MethodError BoundingBox((0mm, 3mm), 1mm, 2mm, 4mm)
        @test_throws MethodError BoundingBox((0mm, 6mm, 3mm, 8mm), 1mm, 2mm, 4mm)
    end
end

@testset "Measure constructors" begin
    @testset "Length constructor" begin
        @test Length(:mm, 1) === Length{:mm, Int}(1)
        @test Length(:mm, 1.1) === Length{:mm, Float64}(1.1)
        @test 1mm |> typeof === Length{:mm, Float64}
        @test convert(Length{:mm, Float64}, 1imm) |> typeof === Length{:mm, Float64}
    end


end

function check_binop(∘) #\circ
    @test (1imm ∘ 2imm).value === 1 ∘ 2
    @test (1mm ∘ 2imm).value === 1.0 ∘ 2
    @test (2mm ∘ 1imm).value === 2.0 ∘ 1
    @test (typeof(2mm ∘ 3xx) <: Length) === false
    @test typeof(2mm ∘ 3xx) <: Measures.BinaryOp
end

function check_unaryop(>:)
    @test >:1imm.value === >:1
    @test >:1.0imm.value !== >:1
    @test >:1.0imm.value === >:1.0
end

@testset "operators" begin
    @testset "type promotion in +" begin
        @test typeof(1imm + 2imm) === Length{:mm, Int}
        @test typeof(1imm + 2mm) === Length{:mm, Float64}
        @test typeof(1mm + 3xx) === Measures.Add{Length{:mm, Float64}, Length{:xx, Float64}}
    end

    @testset "equality" begin
        @test 1imm == 1mm
        @test 1imm !== 1xx
        @test 1imm + 1xx !== 1mm + 1xx # perhaps make this true?
    end

    @testset "hash" begin
        @test hash(1imm) === hash(1mm)
        @test hash(1imm) !== hash(1xx)
        @test isequal(1imm, 1mm)
        @test isequal(1imm, 1xx) === false
    end

    @testset "+" begin
        check_unaryop(+)
        check_binop(+)
    end
    @testset "-" begin
        check_unaryop(-)
        check_binop(-)
    end
    @testset "max" begin
        check_binop(max)
    end
    @testset "min" begin
        check_binop(max)
    end
    @testset "broadcasting" begin
        a = [1mm, 2mm, 3mm]
        @test all((a .+ 1mm) .== [2mm, 3mm, 4mm])
    end

    @testset "Length methods" begin
        @test oneunit(Length{:mm, Int}) == 1mm
        @test !isabsolute(Length{:w, Float32})
    end
end

@testset "range" begin
    @test collect(range(0mm, 1mm, length=3)) == [0mm, 0.5mm, 1mm]
end

struct BoundingBox{P1 <: Vec, P2 <: Vec}
    x0::P1
    a::P2
end

BoundingBox(x0::P, width::T1, height::T2) where {P <: Vec2, T1 <: Measure, T2 <: Measure} =
    BoundingBox{P, Tuple{T1, T2}}(x0, (width, height))

BoundingBox(x0::P, width::T1, height::T2, depth::T3) where {P <: Vec3, T1 <: Measure, T2 <: Measure, T3 <: Measure} =
    BoundingBox{P, Tuple{T1, T2, T3}}(x0, (width, height, depth))

BoundingBox(x0::Measure, y0::Measure, width::Measure, height::Measure) =
    BoundingBox((x0, y0), width, height)

BoundingBox(x0::Measure, y0::Measure, z0::Measure, width::Measure, height::Measure, depth::Measure) =
    BoundingBox((x0, y0, z0), width, height, depth)

BoundingBox() = BoundingBox(0mm, 0mm, 1w, 1h)
BoundingBox(width, height) = BoundingBox(0mm, 0mm, width, height)
BoundingBox(width, height, depth) = BoundingBox(0mm, 0mm, 0mm, width, height, depth)

isabsolute(b::BoundingBox{P1, P2}) where {P1, P2} = isabsolute(b.x0) && isabsolute(b.a)

const AbsoluteBox{N} = BoundingBox{NTuple{N, Length{:mm, Float64}},
                                   NTuple{N, Length{:mm, Float64}}}
const Absolute2DBox  = BoundingBox{Tuple{AbsoluteLength, AbsoluteLength},
                                   Tuple{AbsoluteLength, AbsoluteLength}}
const Absolute3DBox  = BoundingBox{
                                    Tuple{
                                        AbsoluteLength,
                                        AbsoluteLength,
                                        AbsoluteLength
                                    },
                                    Tuple{
                                        AbsoluteLength,
                                        AbsoluteLength,
                                        AbsoluteLength
                                    }
                                }

width(x::BoundingBox)  = x.a[1]
height(x::BoundingBox) = x.a[2]
depth(x::BoundingBox)  = x.a[3]
